#ifndef FOCUSEDCOLUMNMODULE__H
#define FOCUSEDCOLUMNMODULE__H

#include <torch/torch.h>
#include "Submodule.hpp"
#include "MyModule.hpp"
#include "LSTM.hpp"
#include "GRU.hpp"

class FocusedColumnModule : public Submodule
{
  private :

  std::shared_ptr<MyModule> myModule{nullptr};
  std::vector<int> focusedBuffer, focusedStack;
  std::string column;
  int maxNbElements;

  public :

  FocusedColumnModule(std::vector<int> focusedBuffer, std::vector<int> focusedStack, std::string column, int maxNbElements, int embeddingsSize, int outEmbeddingsSize, MyModule::ModuleOptions options);
  torch::Tensor forward(torch::Tensor input);
  std::size_t getOutputSize() override;
  std::size_t getInputSize() override;
  void addToContext(std::vector<std::vector<long>> & context, Dict & dict, const Config & config, bool splitUnknown) const override;
};

#endif

