#ifndef GRUNETWORK__H
#define GRUNETWORK__H

#include "NeuralNetwork.hpp"
#include "ContextModule.hpp"
#include "RawInputModule.hpp"
#include "SplitTransModule.hpp"
#include "FocusedColumnModule.hpp"
#include "DepthLayerTreeEmbeddingModule.hpp"
#include "MLP.hpp"

class GRUNetworkImpl : public NeuralNetworkImpl
{
//  private :
//
//  torch::nn::Embedding wordEmbeddings{nullptr};
//  torch::nn::Dropout2d embeddingsDropout2d{nullptr};
//  torch::nn::Dropout embeddingsDropout{nullptr};
//  torch::nn::Dropout inputDropout{nullptr};
//
//  MLP mlp{nullptr};
//  ContextModule contextGRU{nullptr};
//  RawInputModule rawInputGRU{nullptr};
//  SplitTransModule splitTransGRU{nullptr};
//  DepthLayerTreeEmbeddingModule treeEmbedding{nullptr};
//  std::vector<FocusedColumnModule> focusedLstms;
//  std::map<std::string,torch::nn::Linear> outputLayersPerState;

  public :

  GRUNetworkImpl(std::map<std::string,std::size_t> nbOutputsPerState, int unknownValueThreshold, std::vector<int> bufferContext, std::vector<int> stackContext, std::vector<std::string> columns, std::vector<int> focusedBufferIndexes, std::vector<int> focusedStackIndexes, std::vector<std::string> focusedColumns, std::vector<int> maxNbElements, int leftWindowRawInput, int rightWindowRawInput, int embeddingsSize, std::vector<std::pair<int, float>> mlpParams, int contextGRUSize, int focusedGRUSize, int rawInputGRUSize, int splitTransGRUSize, int numLayers, bool bigru, float gruDropout, std::vector<std::string> treeEmbeddingColumns, std::vector<int> treeEmbeddingBuffer, std::vector<int> treeEmbeddingStack, std::vector<int> treeEmbeddingNbElems, int treeEmbeddingSize, float embeddingsDropoutValue, float totalInputDropout, bool drop2d);
  torch::Tensor forward(torch::Tensor input) override;
  std::vector<std::vector<long>> extractContext(Config & config, Dict & dict) const override;
};

#endif
