#ifndef RAWINPUTMODULE__H
#define RAWINPUTMODULE__H

#include <torch/torch.h>
#include "Submodule.hpp"
#include "MyModule.hpp"
#include "LSTM.hpp"
#include "GRU.hpp"

class RawInputModule : public Submodule
{
  private :

  std::shared_ptr<MyModule> myModule{nullptr};
  int leftWindow, rightWindow;

  public :

  RawInputModule(int leftWindow, int rightWindow, int embeddingsSize, int outEmbeddingsSize, MyModule::ModuleOptions options);
  torch::Tensor forward(torch::Tensor input);
  std::size_t getOutputSize() override;
  std::size_t getInputSize() override;
  void addToContext(std::vector<std::vector<long>> & context, Dict & dict, const Config & config, bool splitUnknown) const override;
};

#endif

