#ifndef SUBMODULE__H
#define SUBMODULE__H

#include <torch/torch.h>
#include "Dict.hpp"
#include "Config.hpp"

class Submodule : public torch::nn::Module
{
  protected :

  std::size_t firstInputIndex{0};

  public :

  void setFirstInputIndex(std::size_t firstInputIndex);
  virtual std::size_t getOutputSize() = 0;
  virtual std::size_t getInputSize() = 0;
  virtual void addToContext(std::vector<std::vector<long>> & context, Dict & dict, const Config & config, bool splitUnknown) const = 0;
  virtual torch::Tensor forward(torch::Tensor input) = 0;
};

#endif

